/******************************************************************************
***																			***
***						jB Crypto KeygenMe # 02								***
***						   Keygen par Bigbang								***
***																			***
***	NOTES:																	***
***																			***
***		Ce keygen utilise la mthode Rho de Pollard	implmente en partie 	***
***		dans index.c de la doc MIRACL pour rsoudre le logarithme discret	***
***																			***
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "include/miracl.h"
//#include "global.h"
#include "sha256.h"

#define NPRIMES 9

static big p,p1,order,lim1,lim2;

char cste[]={0x76,0x7B,0xE6,0x20,0x21,0xC4,0x73,0x22,0x42,0xED,0x0F,0xF9,0x97,0xAE,0x66,0x80,0x11,0x9C,0xB3,0x27,0x53,0x34,0xA7,0xBE,0xD8,0x7A,0xD5,0x2F,0x5E,0xB6,0x8E,0xCD,0xB0,0x8F,0x6E,0x00};

int str2dword(unsigned char *input)
{
  int dword;
  dword = ((int)input[3]) | (((int)input[2]) << 8) |
   (((int)input[1]) << 16) | (((int)input[0]) << 24);
  return dword;
}

void iterate(big x,big q,big r,big a,big b)
{ /* apply Pollards random mapping */
    if (compare(x,lim1)<0)
    {
        mad(x,q,q,p,p,x);
        incr(a,1,a);
        if (compare(a,order)==0) zero(a);
        return;
    }
    if (compare(x,lim2)<0)
    {
        mad(x,x,x,p,p,x);
        premult(a,2,a);
        if (compare(a,order)>=0) subtract(a,order,a);
        premult(b,2,b);
        if (compare(b,order)>=0) subtract(b,order,b);
        return;
    }
    mad(x,r,r,p,p,x);
    incr(b,1,b);
    if (compare(b,order)==0) zero(b);
}

long rho(big q,big r,big m,big n)
{ /* find q^m = r^n */
    long iter,rr,i;
    big ax,bx,ay,by,x,y;
    ax=mirvar(0);
    bx=mirvar(0);
    ay=mirvar(0);
    by=mirvar(0);
    x=mirvar(1);
    y=mirvar(1);
    iter=0L;
    rr=1L;
    do
    { /* Brent's Cycle finder */
        copy(y,x);
        copy(ay,ax);
        copy(by,bx);
        rr*=2;
        for (i=1;i<=rr;i++)
        {
            iter++;
            iterate(y,q,r,ay,by);
            if (compare(x,y)==0) break;
        }
    } while (compare(x,y)!=0);

    subtract(ax,ay,m);
    if (size(m)<0) add(m,order,m);
    subtract(by,bx,n);
    if (size(n)<0) add(n,order,n);
    mirkill(y);
    mirkill(x);
    mirkill(by);
    mirkill(ay);
    mirkill(bx);
    mirkill(ax);
    return iter;
}

void RemEucl(unsigned int a,char r[8])
{
    int i,j,len,rem;
	char tmp;
    char rr[8];
    
	//printf("a=%X\t",a);

    i=0;rem=0;
    while(a>0x20)
    {
		rem=a%0x20;
		if(rem<=0x19) r[i]=rem+0x41;
		if(rem>=0x1A) r[i]=rem+0x16;
        a/=0x20;
        i++;
    }
	if(a<=0x19) r[i]=a+0x41;
	if(a>=0x1A) r[i]=a+0x16;
	r[i+1]=0;

	len=strlen(r);

    for(i=0,j=len-1;i<len;i++,j--) rr[j]=r[i];
    rr[i]=0;

	for(i=0;i<len;i++) r[i]=rr[i];
	r[i]='6';
	r[i+1]=0;

	//printf("r=\t%s\n",r);

}


int main()
{
    char name[48];
	char hash[48];
	char id[48];
	char serial[48];
	char serialf[100];

	char eucl[8];
	unsigned int itmp;

    int i,np=NPRIMES;
    long iter;
    big pp[NPRIMES],rem[NPRIMES];
    big m,n,Q,R,q,w,x,proot;
	big big_hash,big_p,big_mod,big_mod2,big_un;
    FILE *fout;
    big_chinese bc;
    miracl *mip=mirsys(100,0);

	// pour le hash sha256
    sha256_context ctx;
    unsigned char sha256sum[32];

	for(i=0;i<48;i++)
	{
		name[i]=0;
		hash[i]=0;
		serial[i]=0;
		id[i]=0;
	}

	for(i=0;i<8;i++) eucl[i]=0;
	itmp=0;
	for(i=0;i<100;i++) serialf[i]=0;

    printf("jB Crypto KeygenMe 2\nKeygen by Bigbang\n\nAttention : la generation du serial demande environ une minute.\nName:\t");
    gets(name);

	// on hash le nom
	sha256_starts(&ctx);
	sha256_update(&ctx,(uint8 *)name,strlen(name));
	sha256_finish(&ctx,sha256sum);

	// n-1 dcompos en produit de facteurs premiers
    pp[0]=mirvar(0);
    pp[1]=mirvar(0);
    pp[2]=mirvar(0);
    pp[3]=mirvar(0);
	pp[4]=mirvar(0);
	pp[5]=mirvar(0);
	pp[6]=mirvar(0);
	pp[7]=mirvar(0);
	pp[8]=mirvar(0);    
    proot=mirvar(0);	// proot = a
    q=mirvar(0);
    Q=mirvar(0);
    R=mirvar(0);
    w=mirvar(0);
    m=mirvar(0);
    n=mirvar(0);
    x=mirvar(0);
    p=mirvar(0);
    p1=mirvar(1);
    order=mirvar(0);
    lim1=mirvar(0);
    lim2=mirvar(0);
	big_hash=mirvar(0);
	big_p=mirvar(0);
	big_mod=mirvar(0);
	big_mod2=mirvar(0);
	big_un=mirvar(1);


	cinstr(pp[0],"2");
	cinstr(pp[1],"2815877");
	cinstr(pp[2],"29111609");
	cinstr(pp[3],"886858327");
	cinstr(pp[4],"7420154887");
	cinstr(pp[5],"51016951651");
	cinstr(pp[6],"7332402496481");
	cinstr(pp[7],"535680266029");
	cinstr(pp[8],"7332402471571");
	cinstr(proot,"1168564702938616060860205625779134330139232618057968293581930542603891111661536226");	// proot = a
	cinstr(big_p,"689219980367200448228233469551774431281832371213335848762696196467567412087213050");
	cinstr(big_mod,"1585221117854722153076651463706576284202774603262818801054484035317780332416731107");
	cinstr(big_mod2,"7332402496481");

	// le hash se prsente renvers dans le keygenme.
	// on fait donc la mme chose
	__asm
	{
		xor		ecx, ecx
_bswp:
		mov		eax, dword ptr [sha256sum+4*ecx]
		bswap 	eax
		mov		dword ptr [sha256sum+4*ecx], eax

		inc		ecx
		cmp		ecx,8
		jne		short _bswp
	}

	strcpy(serial,sha256sum);

	sprintf(hash,"%.8X%.8X%.8X%.8X%.8X%.8X%.8X%.8X",str2dword(sha256sum+0),
									str2dword(sha256sum+4),
									str2dword(sha256sum+8),
									str2dword(sha256sum+12),
									str2dword(sha256sum+16),
									str2dword(sha256sum+20),
									str2dword(sha256sum+24),
									str2dword(sha256sum+28));

	//printf("hash:\t%s\n\n",hash);

	mip->IOBASE=16;
	cinstr(big_hash,hash);
	mip->IOBASE=10;
	
	powmod(big_p,big_hash,big_mod,q);		// q = big_p ^ big_hash (modulo big_mod)
/*
	mip->IOBASE=16;
	printf("big_p=\n");cotnum(big_p,stdout);
	printf("big_hash=\n");cotnum(big_hash,stdout);
	printf("big_mod=\n");cotnum(big_mod,stdout);
	printf("q=\n");cotnum(q,stdout);
	system("pause");
	return 0;
*/
	mip->IOBASE=10;
	for (i=0;i<np;i++) multiply(p1,pp[i],p1);
    incr(p1,1,p);

    subdiv(p,3,lim1);
    premult(lim1,2,lim2);

    for (i=0;i<NPRIMES;i++) rem[i]=mirvar(0);

    crt_init(&bc,np,pp);

    for (i=0;i<np;i++)
    { // accumulate solutions for each pp 
        copy(p1,w);
        divide(w,pp[i],w);
        powmod(q,w,p,Q);
        powmod(proot,w,p,R);
        copy(pp[i],order);
        iter=rho(Q,R,m,n);
        xgcd(m,order,w,w,w);
        mad(w,n,n,order,order,rem[i]);
    }
    crt(&bc,rem,x);   // apply Chinese remainder thereom
    
	powmod(x,big_un,big_mod2,x);

	mip->IOBASE=10;

	cotstr(x,id);	// on a l'id
    crt_end(&bc);

	// on s'occupe maintenant du serial
	serial[32]=0;
	serial[33]=0;
	serial[34]=0;
	serial[35]=0;
	for(i=0;i<36;i++) serial[i] ^= cste[i];

	__asm
	{
		lea		eax,serial
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+4
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+8
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+12
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+16
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+20
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+24
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+28
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+32
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);

	__asm
	{
		lea		eax,serial+36
		mov		eax, DWORD PTR [eax]
		mov		itmp, eax
	}
	RemEucl(itmp,eucl);
	strcat(serialf,eucl);
	//printf("\nici\teucl=\t%s\n",eucl);


	// affichage des rsultats
	printf("id:\t%s\n",id);
	printf("serial=\t%s\n",serialf);

	// criture dans un fichier
	fout=fopen("jB KeygenMe 2 - Serial by Bigbang.txt","w");
		fputs("Autor: jB [Crypto KeygenMe 2]\nKeygenner: Bigbang\n\n",fout);
		fputs("Name:\t",fout);fputs(name,fout);fputs("\n",fout);
		fputs("ID:\t",fout);fputs(id,fout);fputs("\n",fout);
		fputs("Serial:\t",fout);fputs(serialf,fout);
	fclose(fout);

	printf("\n\nSee jB KeygenMe 2 - Serial by Bigbang.txt\n\n");

    system("pause");
    return 0;
}

